package io.renren.controller;

import java.util.Date;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import io.renren.annotation.Login;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.dto.EmergencyContactDTO;
import io.renren.entity.EmergencyContactEntity;
import io.renren.service.AppSysLoanApplyService;
import io.renren.service.EmergencyContactService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import springfox.documentation.annotations.ApiIgnore;


/**
 * 
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-11
 */
@RestController
@RequestMapping("api/emergencycontact")
@Api(tags="紧急联系人")
public class EmergencyContactController extends AbstractController{
    @Autowired
    private EmergencyContactService emergencyContactService;
    
    @Autowired
    private AppSysLoanApplyService appSysLoanApplyService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @Login
    public Result<PageData<EmergencyContactDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
    	params.put("userId", getUserId());
        PageData<EmergencyContactDTO> page = emergencyContactService.page(params);

        return new Result<PageData<EmergencyContactDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @Login
    public Result<EmergencyContactDTO> get(@PathVariable("id") Long id){
        EmergencyContactDTO data = emergencyContactService.get(id);

        return new Result<EmergencyContactDTO>().ok(data);	
    }

    @PostMapping
    @ApiOperation("保存")
    @Login
    public Result save(@RequestBody List<EmergencyContactEntity> list,Integer step){
    	if(list.isEmpty()) {
    		return new Result().error("缺少必要参数");
    	}
    	for (EmergencyContactEntity dto : list) {
    		//效验数据
    		ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
    		dto.setUserId(getUserId());
    		dto.setCreateDate(new Date());
		}
       
        emergencyContactService.insertBatch(list);
        if(null != step) {
        	appSysLoanApplyService.updateLoanStep(step);
        }
        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @Login
    public Result update(@RequestBody List<EmergencyContactEntity> list,Integer step){
    	if(list.isEmpty()) {
    		return new Result().error("缺少必要参数");
    	}
        emergencyContactService.updateBatchById(list);
        
        if(null != step) {
        	appSysLoanApplyService.updateLoanStep(step);
        }
        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @Login
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");

        emergencyContactService.delete(ids);

        return new Result();
    }
    
    @GetMapping("/getContactByUserId")
    @ApiOperation("获取当前登录用户的联系人")
    @Login
    public Result<List<EmergencyContactEntity>> getContactByUserId(){

        return new Result<List<EmergencyContactEntity>>().ok(emergencyContactService.getContactByUserId(getUserId()));	
    }

}